# This is the counterpart for the bnusers_master.tcl
# Please pay attention to the configure.
# Comments, suggestions and bugreports to cmouse@fiiu.org
# read bnusers_master.tcl for additional information

# VERSION HISTORY
# v4.0
# Added new command .bnchan
# 
# v3.1
# Fixed bugs in .bnchanset
# Added .bnrestart
# Removed error messages from wrong password etc.
# v3.0
# Added .bndie, .bnjoin, .bnpart and .bnchanset
# Fixed minor mistakes
# v2.0
# Fixed the bug in .bnsay and .bnmsg
# Added .bnrehash, .bnbotattr
# v1.0
# From here it all starts... =)

# SLAVE SIDE

# IMPORTANT! THIS MUST NOT BE changeme!
# This is the one of the most important
# fake msg preventers since we can't see
# the hostmask. If not changed the script
# WILL NOT start

set cipher "changeme"

# Set the following lists to bot names you wish to be able to do the command
# Please note that the letter are all in small. do _not_ use any capital letters
# example:
# set allow(ab) {codem sleazyjack horax}
# If you do not want anyone to be able to use the command
# just leave it empty
#
# example:
# set allow(die) {}

# Here are the settings

# Allow bot adding
set allow(ab) {changethis}

# Allow user adding
set allow(au) {changethis}

# Allow deleting of users
set allow(du) {changethis}

# Allow hostlist editing
set allow(hl) {changethis}

# Allow mode changes
set allow(ca) {changethis}

# Allow password changing
set allow(cp) {changethis}

# Allow channel say
set allow(say) {changethis}

# Allow msg'ing
set allow(msg) {changethis}

# Allow channel joining/parting
set allow(ac) {changethis}

# Allow channel mode setting(chanmode, +bitch, -autoop, etc.)[1/0]
set allow(cset) {changethis}

set allow(chancmd) {changethis}

# Allow rehash] default is {}
set allow(rhh) {}

# Allow restart default/recommended is {}
# This command drops your bot(s) from IRC
# Permanent owner only
set allow(rst) {}

# Allow die default/recommended is {}
# BE CAREFUL WHO YOU GIVE PERMANENT OWNER RIGHTS!!!
# This command can kill your ENTIRE botnet
set allow(die) {}

# Do not touch below

bind bot - "bnrq" bn_receive

if {$cipher=="changeme"} {
  putlog "BOTNET user handle"
  putlog "$owner\(that's you) is a idiot who can't read english!"
  putlog "CHANGE THE BOTNET CIPHER!"
  return 0
}

proc bn_dec {strn} {
 global cipher
 set rep [decrypt $cipher $strn]
 return $rep
}

proc bn_enc {strn} {
 global cipher
 set rep [encrypt $cipher $strn]
 return $rep
}

proc bn_reply {from cmd args} {
 set args [bn_dec $args]
 putlog "$from: $args"
 return 0
}

proc bn_transmit {to transmit} {
 set transmit [bn_enc $transmit]
 putbot $to "bnr $transmit"
 return 0
}

proc bn_receive {to cmd args} {
 set to [string tolower $to]
 global allow owner
 set args [bn_dec $args]
 set args [split $args " "]
 set n -1
 set arg(0) ""
 set arg(1) ""
 set arg(2) ""
 set arg(3) ""
 set arg(4) ""
 set arg(5) ""
 set arg(6) ""
 set arg(7) ""
 set from [string tolower $to]
 foreach argu $args {
   incr n
   set arg($n) $argu
 }
 if {$arg(0)!="bnrq"} { return 0 }
 if {![validuser $to]} { 
     putbot $to "bnrp There was a error"
     return 0
 }
 switch -glob -- $arg(1) {
   "addbot" {
      if {[lsearch $allow(ab) $to]<0} {
        bn_transmit $to "Bot adding failed. Not allowed"
        return 0
      }
      set rsp [addbot $arg(2) $arg(4)]
      if {!($rsp)} {
        bn_transmit $to "Bot adding failed. Entry already exists"
        return 0
      }
      setuser $arg(2) HOSTS "$arg(3)"
      bn_transmit $to "Bot $arg(2) added with hostmask $arg(3) and address $arg(4)"
      putcmdlog "Botnet: $from added $arg(2) to user database as bot"
      return 0
  }
   "adduser" {
      if {[lsearch $allow(au) $to]<0} {
        bn_transmit $to "User adding failed. Not allowed"
        return 0
      }
      set rsp [adduser $arg(2) $arg(3)]
      if {!($rsp)} {
        bn_transmit $to "User adding failed. Entry already exists"
        return 0
      }
      setuser $arg(2) HOSTS "$arg(3)"
      bn_transmit $to "User $arg(2) added with hostmask $arg(3)"
      putcmdlog "Botnet: $from added $arg(2) to user database as user"
      return 0
  }
   "deluser" {
      if {[lsearch $allow(du) $to]<0} {
        bn_transmit $to "User adding failed. Not allowed"
        return 0
      }
      if {[matchattr $arg(2) "+n"]} {
	bn_transmit $to "You cannot remove owner!"
	return 0
      }
      set rsp [deluser $arg(2)]
      if {!($rsp)} {
        bn_transmit $to "User deleting failed. No such user"
        return 0
      }
      bn_transmit $to "User $arg(2) deleted"
      putcmdlog "Botnet: $from deleted $arg(2) from user database"
      return 0
  }
   "addhost" {
      if {[lsearch $allow(hl) $to]<0} {
	bn_transmit $to "No hostlist editing for you."
        return 0
       }
       if {![validuser $arg(2)]} {
	bn_transmit $to "No such user"
	return 0
       }
       set hostlist [getuser $arg(2) HOSTS]
       if {[lsearch -exact $hostlist $arg(3)]>-1} {
	bn_transmit $to "$arg(2) has that host already."
	return 0
       }
       setuser $arg(2) HOSTS $arg(3)
       bn_transmit $to "Host $arg(3) added to $arg(2)"
       putcmdlog "Botnet: $to added a host to $arg(2)"
       return 0
   }
   "delhost" {
      if {[lsearch $allow(hl) $to]<0} {
        bn_transmit $to "No hostlist editing for you."
        return 0
       }
       if {![validuser $arg(2)]} {
        bn_transmit $to "No such user"
        return 0
       }
       set hostlist [getuser $arg(2) HOSTS]
       if {[lsearch -exact $hostlist $arg(3)]==-1} {
        bn_transmit $to "$arg(2) doesn't have that host."
        return 0
       }
       delhost $arg(2) $arg(3)
       bn_transmit $to "Host $arg(3) deleted from $arg(2)"
       putcmdlog "Botnet: $to deleted a host from $arg(2)"
       return 0
   }
   "giveattr" {
      if {[lsearch $allow(ca) $to]<0} {
	bn_transmit $to "No mode viewing/changing allowed."
	return 0
      }
      if {[string match "*#*" $arg(3)]==0} { 
         set rsp [chattr $arg(2)]
      } else {
         set rsp [chattr $arg(2) $arg(3)]
      }
      if {$rsp=="*"} {
	bn_transmit $to "No such user"
	return 0
      }
      bn_transmit $to "User $arg(2) modes: $rsp"
      putcmdlog "Botnet: $from requested $arg(2)'s modes"
      return 0
  }
   "botattr" {
      if {[lsearch $allow(ca) $to]<0} {
       bn_transmit $to "No mode viewing/changing allowed."
       return 0
      }
      if {[string match "*#*" $arg(4)]==0} { 
         set rsp [chattr $arg(2) $arg(3)]
      } else {
         set rsp [chattr $arg(2) $arg(3) $arg(4)]
      }
      if {$rsp=="*"} {
	bn_transmit $to "No such bot"
	return 0
      }
      bn_transmit $to "User $arg(2) modes: $rsp" 
      putcmdlog "Botnet: $from changed $arg(2)'s modes"
      return 0
  }
   "chattr" {
      if {[lsearch $allow(ca) $to]<0} {
	bn_transmit $to "No mode viewing/changing allowed."
	return 0
      }
      if {[string match "*#*" $arg(4)]==0} { 
         set rsp [chattr $arg(2) $arg(3)]
      } else {
         set rsp [chattr $arg(2) $arg(3) $arg(4)]
      }
      if {$rsp=="*"} {
	bn_transmit $to "No such user"
	return 0
      }
      bn_transmit $to "User $arg(2) modes: $rsp" 
      putcmdlog "Botnet: $from changed $arg(2)'s modes"
      return 0
  }
   "passwd" {
      if {[lsearch $allow(cp) $to]<0} {
	bn_transmit $to "No password changes allowed."
	return 0
      }
      if {![validuser $arg(2)]} {
	bn_transmit $to "No such user."
	return 0
      }
      setuser $arg(2) PASS $arg(3)
      bn_transmit $to "Password changed for user $arg(2)"
      putcmdlog "Botnet: $from changed $arg(2)'s password"
      return 0
  }
   "say" {
      if {[lsearch $allow(say) $to]<0} {
	bn_transmit $to "No channel messages allowed."
	return 0
      }
      if {![botonchan $arg(2)]} {
	bn_transmit $to "Not on channel $arg(2)"
	return 0
      }
      puthelp "PRIVMSG $arg(2) :[lrange $args 3 end]"
      bn_transmit $to "Said that to channel $arg(2)"
      putcmdlog "Botnet: $to made me speak to channel $arg(2)"
      return 0
  }
   "msg" {
      if {[lsearch $allow(msg) $to]<0} {
	bn_transmit $to "No private messages allowed."
	return 0
      }
      puthelp "PRIVMSG $arg(2) :[lrange $args 3 end]"
      bn_transmit $to "Said that to $arg(2)"
      putcmdlog "Botnet: $to made me speak to $arg(2)"
      return 0
  }
   "rehash" {
      if {[lsearch $allow(rhh) $to]<0} {
	bn_transmit $to "You may not rehash this bot."
        return 0
       }
       bn_transmit $to "Rehashing..."
       putcmdlog "Botnet: $arg(2)@$to ordered a rehash"
       rehash
       return 0
  }
   "join" {
      if {[lsearch $allow(ac) $to]<0} {
        bn_transmit $to "Channel joining not allowed."
        return 0
       }
       foreach chan [channels] {
        if {[string tolower $arg(2)]==[string tolower $chan]} {
          bn_transmit $to "I'm on $arg(2) already!"
          return 0
        }
       }
       channel add $arg(2)
       bn_transmit $to "Joined channel $arg(2)"
       putcmdlog "$to made me join $arg(2)"
       return 0
   }
   "part" {
      if {[lsearch $allow(ac) $to]<0} {
        bn_transmit $to "Channel joining not allowed."
        return 0
       }
       set ioc 0
       foreach chan [channels] {
        if {[string tolower $arg(2)]==[string tolower $chan]} {
         set ioc 1
        }
       }
       if {!($ioc)} {
        bn_transmit $to "I'm not on channel $arg(2)!"
        return 0
       }
       channel remove $arg(2)
       bn_transmit $to "Left channel $arg(2)"
       putcmdlog "$to made me left $arg(2)"
       return 0
   }
   "die" {
      if {[lsearch $allow(die) $to]<0} {
	putcmdlog "BOTNET: Killing not allowed"
        return 0
       }
       if {[lsearch $owner $arg(2)]<0} {
	putcmdlog "BOTNET: $arg(2) is not a permowner"
        return 0
       }
       putcmdlog "$arg(2)@$to killed me"
       die [lrange $args 3 end]
   }
   "chanset" {
      if {[lsearch $allow(cset) $to]<0} {
        bn_transmit $to "Channel mode setting not allowed"
        return 0
      }
      set ioc 0
      foreach chan [channels] {
         set chan [string tolower $chan]
         if {$arg(2)==$chan} { set ioc 1 }
      }
      if {$ioc==0} {
         bn_transmit $to "I'm not on channel $arg(2)!"
         return 0
      }
      if {[string tolower $arg(3)]=="chanmode"} {
         channel set $arg(2) $arg(3) [lrange $args 4 end]
	 putlog "$arg(2) $arg(3) [lrange $args 4 end]"
      } else {
         channel set $arg(2) $arg(3) $arg(4) $arg(5) $arg(6) $arg(7)
      }
      bn_transmit $to "Mode set for $arg(2)" 
      return 0
   }
   "chancmd" {
      set arg(2) [string tolower $arg(2)]
      if {[lsearch $allow(chancmd) $to]<0} {
        bn_transmit $to "BOTNET: Channel cmd's not allowed"
        return 0
      }
      if {(![onchan $arg(3) $arg(4)])&&($arg(2)!="invite")} {
         bn_transmit $to "BOTNET: No such user on $arg(4)"
         return 0
      }
      switch -exact $arg(2) {
       "op" { putserv "MODE $arg(4) +o $arg(3)" }
       "deop" { putserv "MODE $arg(4) -o $arg(3)" }
       "voice" { putserv "MODE $arg(4) +v $arg(3)" }
       "devoice" { putserv "MODE $arg(4) -v $arg(3)" }
       "kick" { putserv "KICK $arg(4) $arg(3) :[lrange $args 4 end]" }
       "invite" { putserv "INVITE $arg(3) $arg(4)" }
      }
      return 0
   }
   "restart" {
      if {[lsearch $allow(rst) $to]<0} {
	putcmdlog "BOTNET: Killing not allowed"
        return 0
       }
       if {[lsearch $owner $arg(2)]<0} {
	putcmdlog "BOTNET: $arg(2) is not a permowner"
        return 0
       }
       putcmdlog "$arg(2)@$to restarted me"
       restart
       return 0
   }
    
}
putbot $to "bnrp Unknown command - this should not occur, check version"
return 0
}

putlog "Botnet userlist handler slave v3.2"
